var $ = function(element) {
    return document.getElementById(element);
};

var Tools = {};
    Tools.createTime = function(time) {
        var locale = Twippera.config.locale;
        var t = time.split(' ');
        var Month = {
            'Jan' : 0,
            'Feb' : 1,
            'Mar' : 2,
            'Apr' : 3,
            'May' : 4,
            'Jun' : 5,
            'Jul' : 6,
            'Aug' : 7,
            'Sep' : 8,
            'Oct' : 9,
            'Nov' : 10,
            'Dec' : 11
        };

        var y = parseInt(t[5]);
        var m = Month[t[1]];
        var d = parseInt(t[2]);
        var time = t[3].split(':')
        var H = parseInt(time[0]);
        var M = parseInt(time[1]);
        var S = parseInt(time[2]);
        var postTime = Date.UTC(y, m, d, H, M, S);
        var nowTime = new Date().getTime();
        var sa = Math.round((nowTime - postTime) / 60 / 1000);

        if(sa < 1) {
            return SPLangs['less'][locale];
        } else if(sa == 1) {
            return sa + SPLangs['minago'][locale]
        } else if(sa > 1 && sa < 60) {
            return sa + SPLangs['minsago'][locale]
        } else {
            var hours = Math.floor(sa / 60);
            return (hours == 1) ? hours + SPLangs['hrago'][locale] : hours + SPLangs['hrsago'][locale];
        }
    };
    Tools.createHTML = function(text) {
        var self = this;
        var text = text.replace(/&amp;/g, "&")
        text = text.replace(
            /(https?|ftp)(:\/\/[-_.!~*\'a-zA-Z0-9;\/?:\@&=+\$,%#]+)/g,
            function($0){

                // <, > が URL に含まれてしまう問題の解決。
                var tmp = $0.split(/(&gt;|&lt;)/);
                var url = tmp[0];
                var aft = typeof tmp[1] != 'undefined'? tmp[1] : "";

                if(url.indexOf('http://tinyurl.com/') == 0 || url.indexOf('http://z.la/') == 0) {
                    url = DecodeURI(self.resolveTinyUrl($0));
                }
                url = encodeURI(url);
                return '<a href="' + url + '">' + url +'</a>' + aft;
            }
        );
        // @username link
        return text.replace(/@(\w+)/g, function($0, $1) {
            return '@<a href="http://twitter.com/' + $1 + '">' + $1 + '</a>'
        });
    };

    // Tinyurl 展開: 1つに付き about 600ms
    Tools.resolveTinyUrl = function(url) {
        var exURL;
        var xhr = new XMLHttpRequest();
            xhr.open('HEAD', url, false);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4) {
                    exURL = xhr.getResponseHeader('Location');
                }
            }
            xhr.send(null);
        return exURL
    };

//Widget
var Widget = {}
    Widget.setValue = function(value, key) {
        var vals = ""
        switch(value.constructor) {
            case Array:
                vals = value.join(',');
                break;
            case String:
                vals = value;
            case Number:
                vals = value.toString();
            default:
                vals = value;
        }
        widget.setPreferenceForKey(vals, key);
        return this;
    };
    Widget.getValue = function(key, type) {
        var value = widget.preferenceForKey(key);
        if(typeof type != 'undefined') {
            switch(type) {
                case 'Number':
                    return parseInt(value);
                    break;
                case 'Array':
                    return value.split(',');
                    break;
                case 'Object':
                    return eval(value);
                    break;
                default:
                    break;
            }
        } else {
            return value;
        }
    }

// Array
Array.prototype.contains = function(obj) {
    var c = false;
    for(var i=0,len=this.length;i<len;i++) {
        if(this[i] == obj) {
            c = true;
            break;
        }
    }
    return c;
}

Array.prototype.del = function(obj) {
    var r = [];
    for(var i=0,len=this.length;i<len;i++) {
        if(this[i] != obj) {
            r.push(this[i]);
        }
    }
    return r;
}

function setCaretPosition(ctrl, pos) {
    if(ctrl.setSelectionRange) {
        ctrl.focus();
        ctrl.setSelectionRange(pos,pos);
    }
    else if (ctrl.createTextRange) {
        var range = ctrl.createTextRange();
        range.collapse(true);
        range.moveEnd('character', pos);
        range.moveStart('character', pos);
        range.select();
    }
}

//
// TransURI (UTF-8): transURI.js (Ver.041211)
//
// Copyright (C) http://nurucom-archives.hp.infoseek.co.jp/digital/
//

EncodeURI=function(str){
	return str.replace(/[^!#$&-;=?-Z_a-z~]/g,function(s){
		var c=s.charCodeAt(0);
		return (c<16?"%0"+c.toString(16):c<128?"%"+c.toString(16):c<2048?"%"+(c>>6|192).toString(16)+"%"+(c&63|128).toString(16):"%"+(c>>12|224).toString(16)+"%"+(c>>6&63|128).toString(16)+"%"+(c&63|128).toString(16)).toUpperCase()
	})
};

EncodeURIComponent=function(str){
	return str.replace(/[^!'-*.0-9A-Z_a-z~-]/g,function(s){
		var c=s.charCodeAt(0);
		return (c<16?'%0'+c.toString(16):c<128?'%'+c.toString(16):c<2048?'%'+(c>>6|192).toString(16)+'%'+(c&63|128).toString(16):'%'+(c>>12|224).toString(16)+'%'+(c>>6&63|128).toString(16)+'%'+(c&63|128).toString(16)).toUpperCase()
	})
};

DecodeURI=function(str){
	return str.replace(/%(E(0%[AB]|[1-CEF]%[89AB]|D%[89])[0-9A-F]|C[2-9A-F]|D[0-9A-F])%[89AB][0-9A-F]|%[0-7][0-9A-F]/ig,function(s){
		var c=parseInt(s.substring(1),16);
		return String.fromCharCode(c<128?c:c<224?(c&31)<<6|parseInt(s.substring(4),16)&63:((c&15)<<6|parseInt(s.substring(4),16)&63)<<6|parseInt(s.substring(7),16)&63)
	})
};
