// twippera.js

var Twippera = {
    version : '20070913-1',
    release : 24,
    TID     : null,
    XHRID   : null,
    postMsgs : [],
    PMindx  : 0,
    timeout : 30000,
    fcount : 0
}
    Twippera.initEvent = function() {
        var self = this;
        var locale = self.config.locale
        $('header').addEventListener('dblclick', function() {
            self.foldMsgList();
        }, false);
        $('reload').addEventListener('click', function(){
            if(self.ear == 'true') {
                self.autoReflesh();
            } else {
                self.post("friends_timeline");
            }
        }, false);
        $('pref').addEventListener('click', function() {
            if(Widget.getValue('state') == 'front') {
                self.flipWidget('back');
            } else {
                self.flipWidget('front');
            }
        }, false);
        $('close').addEventListener('click', function() {
            window.close();
        }, false);

        $('status').addEventListener('keydown', function(evt) {
            self.watchKeyEvent(evt);
        }, false);

        $('post').addEventListener('click', function() {
            self.post('update');
        }, false);

        $('save').addEventListener('click', function() {
            self.config.init();
        }, false);

        $('about').addEventListener('click', function() {
            self.showPopup(
                '<h2>'+SPLangs.about[locale]+'</h2>' +
                '<p><span>' + SPLangs.version[locale] +'</span>: ' + 
                self.version + ' (<a href="http://widgets.opera.com/widget/6522">' +
                SPLangs.download[locale] +
                '</a>)</p>' +
                '<p>' + SPLangs.author[locale] +
                ': <a href="http://higeorange.com/">Higeorange</a> (<a href="http://twitter.com/higeorange">Twitter</a>)</p>' +
                '<p>' + SPLangs.design[locale] + ': tobetchi (<a href="http://twitter.com/tobetchi">Twitter</a>)</p>' +
                '<h3>' + SPLangs.trans[locale] + '</h3>' +
                '<ul><li>Español: Eduardo Escárez</li>' +
                '<li>Magyor: Tamás Zahola</li>' +
                '<li>Lietuviškai: Gediminas Ryženinas</li>' +
                '</ul>',
                SPLangs.close[locale],
                function() {
                }
            )
        }, false);

        $('pclose').addEventListener('click', function() {
            self.hidePopup();
        }, false);

    };

    // 文字数カウント
    // Post History
    Twippera.watchKeyEvent = function(evt) {
        var status = $('status').value
        var rest   = 140 - status.length;
        switch(evt.keyCode) {
            case 38:
                if(this.postMsgs[this.PMindx + 1] && !evt.shiftKey) {
                    this.showPostHistory('back');
                }
                break;
            case 40:
                if(this.postMsgs[this.PMindx - 1] && !evt.shiftKey) {
                    this.showPostHistory('forward');
                }
                break;
            default:
                break;
        }
        $('count').innerHTML = (rest >= 0) ? rest : 0;
    };
    Twippera.showPostHistory = function(to) {
        var status = $('status')
        if(to == 'back') {
            if(this.PMindx == 0) {
                this.postMsgs[0] = { msg: $('status').value, post: 0};
            }
            this.PMindx += 1;
        } else if (to == 'forward') {
            this.PMindx -= 1;
        }
        status.value = this.postMsgs[this.PMindx].msg;
        setCaretPosition(status, status.value.length);
    };
    // メッセージ折り畳み
    Twippera.foldMsgList = function() {
        switch (Widget.getValue('list')) {
            case "show":
                $('updateList').style.height = '0'
                Widget.setPreferenceForKey('hide', 'list');
                break;
            case "hide":
                $('updateList').style.height = '280px'
                Widget.setValue('show', 'list');
                break;
            default:
                break;
        }
    };
    // from my.opera sample widget
    // 設定画面 / メイン画面
    Twippera.flipWidget = function(to) {
        switch (to) {
            case "back":
                $('front').style.display  = "none";
                $('config').style.display = "block";
                Widget.setValue('back', 'state');
                break;
            case "front":
                $('front').style.display  = "block";
                $('config').style.display = "none";
                Widget.setValue('front', 'state');
                break;
            default:
                break;
        }
    };

    // @付き返信
    Twippera.replyUser = function(user) {
        var status   = $('status');
        var msg = status.value;
            status.value = '@' + user + ' ' + msg;
        setCaretPosition(status, status.value.length);
    };

    Twippera.autoReflesh = function() {
        clearTimeout(this.TID);
        var self = this;
        this.post("friends_timeline");
        this.TID = setTimeout(function(){ self.autoReflesh() }, Twippera.config.time);
    };

    // ポスト, ステータス取得
    Twippera.post = function(type) {
        var self = this;
            self.hidePopup();
        var config = Twippera.config;
        var locale = config.locale;
        var status = "";
        var query = null;
        $('reload').style.backgroundImage = 'url("images/loading.gif")';
        if(type == 'update') {
            status = $('status').value;
            if(status == "") return;
            query = 'status=' + status.replace(/(&|\+|\*|;)/g,
                function($0, $1) {
                    return encodeURIComponent($1);
                }
            ) + '&source=Twippera';
            $('status').value = "";
        } else {
            if(this.fcount > 4) {
                self.favorite.check();
                this.fcount = 0;
            } else {
                this.fcount++;
            }
        }

        var xhr = new XMLHttpRequest();
            xhr.open('POST', 'http://twitter.com/statuses/' + type +'.json', true, config.user, config.pass);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            self.XHRID = setTimeout(function(){ 
                if(xhr.readyState == 0 || xhr.readyState == 4) return;
                xhr.abort();
                self.showPopup(
                    SPLangs.timeout[locale],
                    SPLangs.close[locale],
                    function() {}
                );
                $('reload').style.backgroundImage = 'url("images/reload.gif")';
                clearTimeout(self.XHRID);
            }, this.timeout);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200){
                    clearTimeout(self.XHRID);
                    if(type == 'friends_timeline') {
                        self.cache.update(xhr.responseText);
                    } else if(type == 'update') {
                        if(self.postMsgs[0]) {
                            if(!self.postMsgs[0].post) {
                                self.postMsgs.shift();
                            }
                        }
                        self.postMsgs.unshift({msg: "", post : 0}, {msg: status, post: 1});
                        self.PMindx = 0;
                        self.cache.update('[' + xhr.responseText + ']');
                    }
                    $('reload').style.backgroundImage = 'url("images/reload.gif")';
                    self.watchKeyEvent("");
                }
            }
            xhr.send(query);
    };

    Twippera.config = {
        user    : "",
        pass    : "",
        locale  : "en",
        time    : ""
    };
    Twippera.config.init = function() {
        var user = $('user').value;
        var pass = $('pass').value

        //save user & pass
        this.username = user;
        this.password = pass;
        Widget.setValue(user, 'user');
        Widget.setValue(pass, 'pass');

        if($('sar').checked) {
            var time = parseInt($('reflesh').value) * 1000 * 60;
            Widget.setValue("true", "enableReflesh");
            Widget.setValue(time, "time");
        } else {
            Widget.setValue("false", "enableReflesh");
            clearTimeout(this.TID);
        }

        var timeout = parseInt($('timeout').value) * 1000;
        Widget.setValue(timeout, 'timeout');

// Set Locale
        var localeSel = $("locale");
        var locale = localeSel.options[localeSel.selectedIndex].value;
        Widget.setValue(locale, "locale");

        this.load();
        Twippera.flipWidget('front');
    };
    Twippera.config.load = function() {
        Widget.setValue('front', 'state');
        Widget.setValue('show', 'list');
        this.locale = Widget.getValue("locale") || "en";
        $('locale').selectedIndex = localeIndex[this.locale];
        this.setLocale(this.locale);
        this.user = Widget.getValue('user');
        this.pass = Widget.getValue('pass');
        this.time = Widget.getValue('time');
        this.ear  = Widget.getValue('enableReflesh');
        this.timeout = Widget.getValue('timeout', 'Number')

        $('count').innerHTML = '140';

        if(this.user != "" && this.pass !="") {
            $('user').value = this.user;
            $('pass').value = this.pass;
            Twippera.favorite.check();
            if(this.ear == "true") {
                $("sar").checked = true;
                $("reflesh").value = this.time / 60000; 
                Twippera.autoReflesh(this.time);
            } else {
                $("sar").checked = false;
                Twippera.post('friends_timeline');
            }
            $('timeout').value = this.timeout / 1000;
        } else {
            Twippera.flipWidget("back");
        }
    };
    Twippera.config.setLocale = function(lng) {
        var lang = Langs[lng];
        var save = $('save');
        for(var i in lang) {
            $(i) .innerHTML = lang[i];
        }
    };

    Twippera.cache = {
        list   : []
    };
    Twippera.cache.update = function(txt) {
        eval('var json=(' + txt + ')');

        // [{"id":,"created_at":,"text":,"user":{"name":,"profile_image_url":,"description":,"location":,"url":,"id":,"protected":,"screen_name":}},.....]
        var tmp = []
        for(var i=0, len=json.length; i<len; i++) {

            // キャッシュになければ追加
            if(this.check(json[i]['id'])) {
                tmp.push({
                    id     : json[i]['id'],
                    img    : json[i]['user']['profile_image_url'],
                    usr    : json[i]['user']['screen_name'],
                    msg    : json[i]['text'],
                    time   : json[i]['created_at'],
                    cached : 0
                });
            }

        }
        if(this.list.length == 0) {
            this.list = tmp;
        } else {
            this.list = tmp.concat(this.list);
        }
        this.sort();
        this.parse();
    };
    // id 順にソート
    // 他のソートアルゴリズム実装も考える
    Twippera.cache.sort = function() {
        var list = this.list
        var end = list.length - 1;
        for(var i=0;i<end;i++) {
            for(j=i+1;j<=end;j++){
                if(list[i]['id'] < list[j]['id']) {
                    var tmp = list[i];
                    list[i] = list[j];
                    list[j] = tmp
                }
            }
        }
        this.list = list;
    };
    Twippera.cache.check = function(id) {
        var c = true;
        for(var i=0,len=this.list.length;i<len;i++) {
            if(this.list[i]['id'] == id) {
                c = false;
                break;
            }
        }
        return c;
    };
    Twippera.cache.parse = function() {
        var list = [];
        var user = Twippera.config.user;
        for(var i=0, len=this.list.length; i<len; i++) {
            var usr = this.list[i];

            var li  = document.createElement('li');

            var img = document.createElement('img');
                img.src = usr['img'];
                img.setAttribute('alt', usr['usr']);
                img.style.width = '16px';
                img.style.height = '16px';
                img.setAttribute('onclick', "Twippera.replyUser('" + usr['usr'] + "')");

            var span = document.createElement('span');
                span.setAttribute('class', 'user');
                span.appendChild(document.createTextNode(usr['usr']));

                li.appendChild(document.createTextNode(' '));
                li.appendChild(img);
                li.appendChild(span);
                li.appendChild(document.createTextNode(' : '));

            var msg = document.createElement('span');
            if(usr['msg'].indexOf('@' + user) >= 0 || usr['msg'].indexOf('@<a href="http://twitter.com/' + user + '">' + user + '</a>') >= 0) {
                msg.className = 'tome';
            }
            if(usr.cached) {
                msg.innerHTML = usr['msg'];
            } else {
                var tmpMsg = Tools.createHTML(usr['msg']);
                msg.innerHTML = tmpMsg;
                this.list[i]['msg'] = tmpMsg;
                this.list[i]['cached'] = 1;
            }
                li.appendChild(msg);

            var meta = document.createElement('span');
                meta.setAttribute('class', 'meta');

            var fav = document.createElement('span');
                fav.setAttribute('class', 'fav');
            if(Twippera.favorite.isFavorite(this.list[i]['id'])) {
                fav.style.backgroundImage = 'url("images/icon_star_full.gif")';
            } else {
                fav.style.backgroundImage = 'url("images/icon_star_empty.gif")' ;
            }
                fav.setAttribute("onclick", "Twippera.favorite.toggle(this, " + this.list[i]['id'] + ")");
                fav.innerHTML = "&nbsp;&nbsp;&nbsp;"
                meta.appendChild(fav);

            var time = document.createElement('span');
                time.setAttribute('class', 'post_time');

            var toTwitter = document.createElement('a');
                toTwitter.href = 'http://twitter.com/' + usr['usr'] + '/statuses/' + this.list[i]['id'];
                toTwitter.innerHTML = Tools.createTime(this.list[i]['time']);
                time.appendChild(toTwitter)
                meta.appendChild(time);
                li.appendChild(meta);

            if(i % 2 != 0) {
                li.setAttribute('class', "zebra");
            }
            list.push(li.outerHTML);
        }
        $('updateList').innerHTML = list.join('');
    };

    Twippera.favorite = {
        favorites : []
    };
    Twippera.favorite.check = function() {
        var self = this;
        var config = Twippera.config
        var url = 'http://twitter.com/favorites.json';
        var xhr = new XMLHttpRequest();
            xhr.open("GET", url, false, config.user, config.pass)
            xhr.send(null);
            if(xhr.readyState == 4 && xhr.status == 200) {
                var json = eval(xhr.responseText);
                for(var i=0,len=json.length;i<len;i++) {
                    if(!self.isFavorite(json[i]['id'])) { 
                        self.favorites.push(json[i]['id']);
                    }
                }
            }
    };
    Twippera.favorite.isFavorite = function(id) {
        return this.favorites.contains(id);
    };
    Twippera.favorite.toggle = function(elm, id){
        var curImage = elm.style.backgroundImage;
        elm.style.backgroundImage = "url('images/icon_throbber.gif')";
        var self = this;
        var url;
        var c = false;
        if(this.isFavorite(id)) {
            url = 'http://twitter.com/favourings/destroy/' + id;
            
            c = true;
        } else {
            url = 'http://twitter.com/favourings/create/' + id;
        }
        var xhr = new XMLHttpRequest();
            xhr.open("GET", url, true, this.user, this.pass);
            xhr.send(null);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200) {
                    if(c) {
                        self.favorites = self.favorites.del(id);
                        elm.style.backgroundImage = "url('images/icon_star_empty.gif')";
                    } else {
                        elm.style.backgroundImage = "url('images/icon_star_full.gif')";
                        self.favorites.push(id);
                    }
                } else {
                    elm.style.backgroundImage = curImage;
                }
            }
    };

    Twippera.update = {
        url : 'http://opera.higeorange.com/misc/twippera/twipperaRelease.txt'
    }
    // アップデートチェック
    Twippera.update.check = function() {
        var self = this;
        var locale = Twippera.config.locale;
        var xhr = new XMLHttpRequest();
            xhr.open('GET', this.url);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200) {
                    var t = xhr.responseText.split(':')
                    var release = parseInt(t[0]);
                    var ver = t[1];
                    if(self.release < release) {
                        self.showPopup(
                            SPLangs.update[locale] + ' : ' + ver,
                            SPLangs.download[locale],
                            function() {
                                widget.openURL('http://widgets.opera.com/widget/6522');
                            }
                        );
                    }
                }
            }
            xhr.send(null);
    };

    // ポップアップ処理
    // 引数: メッセージ, ボタンテキスト, ボタンクリック関数
    Twippera.showPopup = function(txt, btntxt, func) {
        var self = this;
        var popup = $('popup');
            popup.style.display = 'block';
        var ppmsg = popup.getElementsByTagName('p')[0];
            ppmsg.innerHTML = txt;
        var btn = document.evaluate(
            './div/div/div/div/p/button',
            popup,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btn.addEventListener(
                'click',
                function(){
                    self.hidePopup();
                    func();
                },
                false
            );
        var btnInner = document.evaluate(
            './span/span',
            btn,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btnInner.innerHTML = btntxt;
    };

    Twippera.hidePopup = function() {
        var popup = $('popup');
            popup.style.display = 'none';
    };

window.addEventListener('load', function() {
    Twippera.config.load();
    Twippera.initEvent()
    Twippera.update.check();
},false);
